/*
	This is part of the PureLS Source code, based off of the
	LiteStep Shell Source code, available from www.litestep.net

	Copyright (C) 2000-2004 The PureLS Development Team

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

	/* Disable "unreferenced formal parameter" compiler warning. */
#ifndef _DEBUG
	#pragma warning ( disable : 4100 )
#endif

	/* Lets just make sure we aren't depending on IE */
#define _WIN32_IE 0x0000

/*** System Includes ***********/
#include <tchar.h>
#include <windows.h>
#include <stdio.h>
/*******************************/

/*** Shell Includes ************/
#include "lsapi.h"
#include "../sdk/include/purels.h"
/*******************************/


INT GetRCInt(LPCTSTR lpKeyName, INT nDefault)
{
	return SH_CFG_GetInt(lpKeyName, nDefault);
}

BOOL GetRCBool(LPCTSTR lpKeyName, BOOL ifFound)
{
	return( GetRCBoolDef( lpKeyName, FALSE ) == ifFound );
}

BOOL GetRCBoolDef(LPCTSTR lpKeyName, BOOL bDefault)
{
	BOOL bRetVal = bDefault;
	LPTSTR ptr = NULL;
	_TCHAR tmpBuf[256] = {0};
	UINT i = 0;

	if (SH_CFG_GetLine(&i, tmpBuf, lpKeyName, 256, FALSE)){
		bRetVal = TRUE;
		ptr = tmpBuf + _tcslen(lpKeyName);
		if (*ptr != 0){
			if (PL_SimpleToken( tmpBuf, NULL, ptr ))
				if (!_tcsicmp(tmpBuf, _T("FALSE")) || !_tcsicmp(tmpBuf, _T("NO")) || !_tcsicmp(tmpBuf, _T("OFF")))
					bRetVal = FALSE;
		}
	}
	return bRetVal;
}

BOOL GetRCString(LPCTSTR lpKeyName, LPTSTR value, LPCTSTR defStr, size_t nMaxLen)
{
	if (value != NULL)
		*value = 0;
	return SH_CFG_GetString(value, lpKeyName, defStr, nMaxLen);
}

COLORREF GetRCColor(LPCTSTR lpKeyName, COLORREF colDef)
{
	return SH_CFG_GetColor(lpKeyName, colDef);
}

BOOL GetRCLine( LPCTSTR pszCommand, LPTSTR pszBuffer, size_t nBufLen, LPCTSTR pszDefault )
{
	BOOL bRetVal = FALSE;
	if (pszBuffer != NULL && nBufLen > 0){
		*pszBuffer = 0;
		if (!SH_CFG_GetParam(NULL, pszBuffer, pszCommand, nBufLen, FALSE) || *pszBuffer == 0){
			if (pszDefault != NULL){
				_tcsncpy(pszBuffer, pszDefault, nBufLen);
				pszBuffer[nBufLen-1] = 0;
			}
		}else
			bRetVal = TRUE;
	}
	return bRetVal;
}

BOOL LSGetVariableEx(LPCTSTR pszKeyName, LPTSTR pszValue, DWORD dwLength)
{
	return(SH_CFG_GetVar(pszValue, pszKeyName, dwLength));
}

BOOL LSGetVariable(LPCTSTR pszKeyName, LPTSTR pszValue)
{
	_TCHAR szTempValue[PLS_MAX_SIZE];
	BOOL bRetVal = FALSE;

	if(SH_CFG_GetVar(szTempValue, pszKeyName, PLS_MAX_SIZE))
	{
		_tcsncpy(pszValue, szTempValue, _tcslen(szTempValue) + 1);
		bRetVal = TRUE;
	}

	return(bRetVal);
}


VOID LSSetVariable(LPCTSTR pszKeyName, LPCTSTR pszValue)
{
	_TCHAR szTempValue[PLS_MAX_SIZE];

	_stprintf(szTempValue, _T("%s %s"), pszKeyName, pszValue);

	SH_CFG_RegisterVar(szTempValue);

	return;
}

