/*----------------------------------------------------------------------
	This is part of the PureLS Source code.

	Copyright (C) 2000-2003 The PureLS Development Team

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
	USA
----------------------------------------------------------------------*/


/*----------------------------------------------------------------------
 Lets just make sure we aren't depending on IE
----------------------------------------------------------------------*/
#define _WIN32_IE 0x0000


/*---System Includes--------------------------------------------------*/
#include <tchar.h>
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
/*---Shell Includes---------------------------------------------------*/
#include "plsapi.h"
/*--------------------------------------------------------------------*/


INT __cdecl MessageBoxPrintf ( UINT uType, LPCTSTR szCaption, LPCTSTR szFormat, ... )
{
	_TCHAR szBuffer [1024];
	va_list pArgList;

	if (szCaption != NULL && szFormat != NULL && *szFormat)
	{
		va_start (pArgList, szFormat);
		_vsntprintf (szBuffer, sizeof(szBuffer) / sizeof(_TCHAR), szFormat, pArgList);
		va_end (pArgList);

		return MessageBox( NULL, szBuffer, szCaption, uType );
	}
	return 0;
}

#ifdef _DEBUG
VOID DebugPrintf ( BOOL bMsgBox, LPCTSTR szCaption, LPCTSTR szFormat, ... )
{
	_TCHAR szBuffer [1024];
	va_list pArgList;

	if (szCaption != NULL && szFormat != NULL && *szFormat)
	{
		va_start (pArgList, szFormat);
		_vsntprintf (szBuffer, sizeof(szBuffer) / sizeof(_TCHAR), szFormat, pArgList);
		va_end (pArgList);

		if (bMsgBox)
		{
			MessageBox (NULL, szBuffer, szCaption, 0);
		}
		else
		{
			OutputDebugString(_T("\n\r"));
			OutputDebugString(szCaption);
			OutputDebugString(_T(": "));
			OutputDebugString(szBuffer);
			OutputDebugString(_T("\n\r"));
		}
	}
	return;
}
#endif /*_DEBUG*/


/*----------------------------------------------------------------------
 END OF FILE
----------------------------------------------------------------------*/
