/*----------------------------------------------------------------------
	This is part of the PureLS Source code.

	Copyright (C) 2000-2002 The PureLS Development Team

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
	USA
----------------------------------------------------------------------*/


#ifndef _PURELS_
#define _PURELS_

#ifndef PLSVER
#define PLSVER 0x0300
#endif

#ifndef _INC_PURELS
#define _INC_PURELS

#include "plsdefs.h"

/*  If defined, the following flags inhibit definition
 *     of the indicated items.
 *
 *  NOLSAPI           - LiteStep Legacy API library
 *  NOLSMSGS          - LM_*, LiteStep Legacy Module messages
 *  NOLSMULTIMON      - LiteStep Legacy Multi-Monitor routines
 *  NOPLSFILE         - PL_f*, file parsing routines
 *  NOPLSBUF          - Buffer manipulation routines
 *  NOPLSGDI          - PL_g*, gdi manipulation routines
 *  NOPLSUTIL         - Various debug/error handling routines
 *  NOSTARTUP         - Startup API library
 *  NOEXCEPT          - Exception management for the Shell.
 */

#include "config.h"
#include "plsapi.h"

#ifndef NOEXCEPT
#include "except.h"
#endif

#ifndef NOSTARTUP
#include "startup.h"
#endif

#ifndef NOLSAPI
#include "lsapi.h"
#endif


#endif /* _INC_PURELS */

#endif /* _PURELS */
