/*------------------------------------------------------------------------------
	This is part of the PureLS Source code.

	Copyright (C) 2000-2003 The PureLS Development Team

    This program is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation; either version 2 of the License, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    this program; if not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
------------------------------------------------------------------------------*/


/*------------------------------------------------------------------------------
 Lets just make sure we aren't depending on IE
------------------------------------------------------------------------------*/
#define _WIN32_IE 0x0000


/*---System Includes----------------------------------------------------------*/
#include <tchar.h>
#include <windows.h>
/*----------------------------------------------------------------------------*/


/*---Global Variables---------------------------------------------------------*/
static FARPROC (WINAPI *fpRegisterShellHook)(HWND, DWORD);

static UINT WM_ShellHook;
/*----------------------------------------------------------------------------*/


/*--------InitShellHook---------------------------------------------------------
 Purpose:
 -
------------------------------------------------------------------------------*/
VOID initShellHook( HWND hWnd )
{
	MINIMIZEDMETRICS mm;

	if(NULL != fpRegisterShellHook)
	{
		return;
	}

	/*
	 * Configure the Win32 window manager to hide windows when they
	 * are minimized.  This must happen before registering the shell
	 * hook.
	 */
	mm.cbSize = sizeof(MINIMIZEDMETRICS);
	SystemParametersInfo(SPI_GETMINIMIZEDMETRICS, mm.cbSize, &mm, 0);

	if(ARW_HIDE != (mm.iArrange & ARW_HIDE))
	{
		mm.iArrange |= ARW_HIDE;
		SystemParametersInfo(SPI_SETMINIMIZEDMETRICS, mm.cbSize, &mm, 0);
	}

	/* Register Shell hook. */
	fpRegisterShellHook = \
		(FARPROC (WINAPI *)(HWND, DWORD))GetProcAddress(
			 GetModuleHandle(_T("SHELL32"))
			,(LPCSTR)((long)0xB5)
		);

	if(NULL != fpRegisterShellHook)
	{
		WM_ShellHook = RegisterWindowMessage(_T("SHELLHOOK"));

		/*On win95, we use the overloaded RegisterShellHook to thunk to the
		 *16 bit side to do the work for us. this gets fixed when the tray
		 *shuts down properly...
		 */
		//fResult = RegisterShellHook(NULL,(BOOL)4);

		fpRegisterShellHook(NULL, TRUE);
		fpRegisterShellHook(hWnd, 3);
	}

	return;
}

/*--------DeinitShellHook-------------------------------------------------------
 Purpose:
 -
------------------------------------------------------------------------------*/
VOID deinitShellHook( HWND hWnd )
{
	MINIMIZEDMETRICS mm;

	if(NULL == fpRegisterShellHook)
	{
		return;
	}

	/* Unregister the Shell hook */
	fpRegisterShellHook(hWnd, 0);
	fpRegisterShellHook = NULL;
	WM_ShellHook = 0;

	mm.cbSize = sizeof(MINIMIZEDMETRICS);
	SystemParametersInfo(SPI_GETMINIMIZEDMETRICS, mm.cbSize, &mm, 0);

	if(ARW_HIDE == (mm.iArrange & ARW_HIDE))
	{
		mm.iArrange &= ~ARW_HIDE;
		SystemParametersInfo(SPI_SETMINIMIZEDMETRICS, mm.cbSize, &mm, 0);
	}

	return;
}

BOOL onShellHook(
	 HWND hWnd
	,UINT uMsg
	,WPARAM wParam
	,LPARAM lParam
)
{
	if(uMsg == WM_ShellHook)
	{
		/*
		 * I'm actually not postive this should be here.  But some
		 * testing shows that this response may be needed.
		 */
		fpRegisterShellHook(hWnd, 5);
		return(TRUE);
	}

	return(FALSE);
	UNREFERENCED_PARAMETER(wParam);
	UNREFERENCED_PARAMETER(lParam);
}

/*--------End Of File---------------------------------------------------------*/
